import {
    world, system
} from "@minecraft/server";
import {
    ActionFormData,
    MessageFormData,
    ModalFormData
} from "@minecraft/server-ui";

world.afterEvents.itemStartUseOn.subscribe((data) => {
    const player = data.source;
    const block = data.block;
    let underBlock = world.getDimension(player.dimension.id).getBlock({ x: player.location.x, y: player.location.y - 1, z: player.location.z });

    if (block.typeId.includes("ox:elv") && data.itemStack == undefined || block.typeId.includes("ox:elv") && data.itemStack.typeId != "minecraft:ender_pearl") {
        if (block.typeId.includes("ox:elv") && !player.isSneaking && !player.isSwimming && underBlock.typeId.includes("ox:elv") && !player.hasTag("Delay῁") && underBlock.location.y == block.location.y) {
            let elBlock = "";
            let topBlock = "";
            let topTwoBlock = "";
            let numBlock = 0;
            let typeBlock = block.typeId.split("_");

            for (let i = 3; i <= 64; i++) {
                if (block.dimension.id == "minecraft:overworld" && block.location.y + i > 320 || block.dimension.id == "minecraft:nether" && block.location.y + i > 128 || block.dimension.id == "minecraft:the_end" && block.location.y + i > 256) {
                    break;
                } else {
                    elBlock = world.getDimension(block.dimension.id).getBlock({ x: block.location.x, y: block.location.y + i, z: block.location.z });
                    topBlock = world.getDimension(block.dimension.id).getBlock({ x: block.location.x, y: block.location.y + i + 1, z: block.location.z });
                    topTwoBlock = world.getDimension(block.dimension.id).getBlock({ x: block.location.x, y: block.location.y + i + 2, z: block.location.z });
                }
                if (elBlock.typeId == block.typeId && !block.hasTag("down_only") && !block.hasTag("locked_mode") && topBlock.typeId == "minecraft:air" || elBlock.typeId == block.typeId && !block.hasTag("down_only") && !block.hasTag("locked_mode") && topTwoBlock.typeId == "minecraft:air" || elBlock.typeId == block.typeId && !block.hasTag("down_only") && !block.hasTag("locked_mode") && topTwoBlock.typeId == "minecraft:water" || elBlock.typeId == block.typeId && !block.hasTag("down_only") && !block.hasTag("locked_mode") && topBlock.typeId == "minecraft:water") {
                    numBlock = 1;
                    player.runCommandAsync("/particle minecraft:eyeofender_death_explode_particle " + block.location.x + " " + (block.location.y + 1.2) + " " + block.location.z + " ");
                    player.runCommandAsync("/particle minecraft:eyeofender_death_explode_particle " + elBlock.location.x + " " + (elBlock.location.y + 1.2) + " " + elBlock.location.z + " ");
                    system.runTimeout(() => {
                        player.runCommandAsync("/playsound mob.evocation_illager.cast_spell @s " + elBlock.location.x + " " + (elBlock.location.y + 1) + " " + elBlock.location.z + " 0.7");
                    }, 3);
                    player.addTag("Delay῁");
                    system.runTimeout(() => {
                        player.removeTag("Delay῁");
                    }, 15);
                    player.runCommandAsync("tp @s " + block.location.x + " " + (block.location.y + i + 1.5) + " " + block.location.z + " ");
                    break;
                } else if (elBlock.typeId == block.typeId && block.hasTag("down_only") || elBlock.typeId == block.typeId && block.hasTag("locked_mode") || elBlock.typeId == block.typeId && topBlock.typeId != "minecraft:air" || elBlock.typeId == block.typeId && topTwoBlock.typeId != "minecraft:air" || elBlock.typeId == block.typeId && topTwoBlock.typeId != "minecraft:water" || elBlock.typeId == block.typeId && topBlock.typeId != "minecraft:water") {
                    player.runCommandAsync("/particle minecraft:sculk_sensor_redstone_particle " + block.location.x + " " + (block.location.y + 1.3) + " " + block.location.z + "");
                    break;
                }
            }
            if (numBlock == 0 && !block.hasTag("down_only") && !block.hasTag("locked_mode") && topBlock.typeId == "minecraft:air" || numBlock == 0 && !block.hasTag("down_only") && !block.hasTag("locked_mode") && topTwoBlock.typeId == "minecraft:air" || numBlock == 0 && !block.hasTag("down_only") && !block.hasTag("locked_mode") && topTwoBlock.typeId == "minecraft:water" || numBlock == 0 && !block.hasTag("down_only") && !block.hasTag("locked_mode") && topBlock.typeId == "minecraft:water") {
                player.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"§l§fThere Are Not Any §o§7' + typeBlock[1].toUpperCase() + ' Elevator"}]}');
            }

        } else if (block.typeId.includes("ox:elv") && player.isSwimming && underBlock.typeId.includes("ox:elv") && !player.hasTag("Delay῁") && underBlock.location.y == block.location.y || block.typeId.includes("ox:elv") && player.isSneaking && underBlock.typeId.includes("ox:elv") && !player.hasTag("Delay῁") && underBlock.location.y == block.location.y) {
            let elBlock = "";
            let topBlock = "";
            let topTwoBlock = "";
            let numBlock = 0;
            let typeBlock = block.typeId.split("_");

            for (let i = 3; i <= 64; i++) {
                if (block.dimension.id == "minecraft:overworld" && block.location.y - i < -64 || block.dimension.id == "minecraft:nether" && block.location.y - i < 0 || block.dimension.id == "minecraft:the_end" && block.location.y - i < 0) {
                    break;
                } else {
                    elBlock = world.getDimension(block.dimension.id).getBlock({ x: block.location.x, y: block.location.y - i, z: block.location.z });
                    topBlock = world.getDimension(block.dimension.id).getBlock({ x: block.location.x, y: block.location.y - i + 1, z: block.location.z });
                    topTwoBlock = world.getDimension(block.dimension.id).getBlock({ x: block.location.x, y: block.location.y - i + 2, z: block.location.z });
                }
                if (elBlock.typeId == block.typeId && !block.hasTag("up_only") && !block.hasTag("locked_mode") && topBlock.typeId == "minecraft:air" || elBlock.typeId == block.typeId && !block.hasTag("up_only") && !block.hasTag("locked_mode") && topTwoBlock.typeId == "minecraft:air" || elBlock.typeId == block.typeId && !block.hasTag("up_only") && !block.hasTag("locked_mode") && topTwoBlock.typeId == "minecraft:water") {
                    numBlock = 1;
                    player.runCommandAsync("/particle minecraft:eyeofender_death_explode_particle " + block.location.x + " " + (block.location.y + 1.2) + " " + block.location.z + " ");
                    player.runCommandAsync("/particle minecraft:eyeofender_death_explode_particle " + elBlock.location.x + " " + (elBlock.location.y + 1.2) + " " + elBlock.location.z + " ");
                    system.runTimeout(() => {
                        player.runCommandAsync("/playsound mob.evocation_illager.cast_spell @s " + elBlock.location.x + " " + (elBlock.location.y + 1) + " " + elBlock.location.z + " 0.7");
                    }, 3);
                    player.addTag("Delay῁");
                    system.runTimeout(() => {
                        player.removeTag("Delay῁");
                    }, 15);
                    player.runCommandAsync("tp @s " + block.location.x + " " + (block.location.y - (i - 1.5)) + " " + block.location.z + " ");
                    break;
                } else if (elBlock.typeId == block.typeId && block.hasTag("up_only") || elBlock.typeId == block.typeId && block.hasTag("locked_mode") || elBlock.typeId == block.typeId && topBlock.typeId != "minecraft:air" || elBlock.typeId == block.typeId && topTwoBlock.typeId != "minecraft:air" || elBlock.typeId == block.typeId && topBlock.typeId != "minecraft:water" || elBlock.typeId == block.typeId && topTwoBlock.typeId != "minecraft:water") {
                    player.runCommandAsync("/particle minecraft:sculk_sensor_redstone_particle " + block.location.x + " " + (block.location.y + 1.3) + " " + block.location.z + "");
                    break;
                }
            }
            if (numBlock == 0 && !block.hasTag("up_only") && !block.hasTag("locked_mode") && topBlock.typeId == "minecraft:air" || numBlock == 0 && !block.hasTag("up_only") && !block.hasTag("locked_mode") && topTwoBlock.typeId == "minecraft:air" || numBlock == 0 && !block.hasTag("up_only") && !block.hasTag("locked_mode") && topTwoBlock.typeId == "minecraft:water" || numBlock == 0 && !block.hasTag("up_only") && !block.hasTag("locked_mode") && topBlock.typeId == "minecraft:water") {
                player.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"§l§fThere Are Not Any §o§7' + typeBlock[1].toUpperCase() + ' Elevator"}]}');
            }
        }
    } else if (block.typeId.includes("ox:elv") && data.itemStack.typeId == "minecraft:ender_pearl") {
        player.runCommandAsync("playsound random.pop2 @s");
        const formDir = new ActionFormData();
        let typeBlock = block.typeId.split("_");

        formDir.title("§l§u" + typeBlock[1].toUpperCase() + " Elevator");

        if (block.hasTag("up_only")) {
            formDir.body("\n§l§fThis §uElevator §fis : §uUp Only" + "\n\n  §l§fChoose What Direction Do You\nWant This §uElevator §fTo Teleport To\n\n");
            formDir.button("§l§uUp & Down");
            formDir.button("§l§uDown Only");
            formDir.button("§l§uLocked");
        } else if (block.hasTag("down_only")) {
            formDir.body("\n§l§fThis §uElevator §fis : §uDown Only" + "\n\n  §l§fChoose What Direction Do You\nWant This §uElevator §fTo Teleport To\n\n");
            formDir.button("§l§uUp & Down");
            formDir.button("§l§uUp Only");
            formDir.button("§l§uLocked");
        } else if (block.hasTag("locked_mode")) {
            formDir.body("\n§l§fThis §uElevator §fis : §uLocked" + "\n\n  §l§fChoose What Direction Do You\nWant This §uElevator §fTo Teleport To\n\n");
            formDir.button("§l§uUp & Down");
            formDir.button("§l§uUp Only");
            formDir.button("§l§uDown Only");
        } else if (!block.hasTag("up_only") && !block.hasTag("down_only")) {
            formDir.body("\n§l§fThis §uElevator §fis : §uUp & Down" + "\n\n  §l§fChoose What Direction Do You\nWant This §uElevator §fTo Teleport To\n\n");
            formDir.button("§l§uUp Only");
            formDir.button("§l§uDown Only");
            formDir.button("§l§uLocked");
        }

        formDir.show(player).then((respone) => {
            if (respone.canceled) {

            } else if (block.hasTag("up_only")) {
                if (respone.selection == 0) {
                    player.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " " + block.typeId);
                    player.runCommandAsync("/particle minecraft:critical_hit_emitter " + block.location.x + " " + (block.location.y + 1.3) + " " + block.location.z);
                    player.runCommandAsync("/playsound block.grindstone.use @a [r=6] " + block.location.x + " " + block.location.y + " " + block.location.z);
                    player.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"§l§fNow This §uElevator §fis : §uUp & Down"}]}');
                } else if (respone.selection == 1) {
                    player.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " " + block.typeId + ' ["ox:down_only"=true]');
                    player.runCommandAsync("/particle minecraft:critical_hit_emitter " + block.location.x + " " + (block.location.y + 1.3) + " " + block.location.z);
                    player.runCommandAsync("/playsound block.grindstone.use @a [r=6] " + block.location.x + " " + block.location.y + " " + block.location.z);
                    player.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"§l§fNow This §uElevator §fis : §uDown Only"}]}');
                } else if (respone.selection == 2) {
                    player.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " " + block.typeId + ' ["ox:locked_mode"=true]');
                    player.runCommandAsync("/particle minecraft:critical_hit_emitter " + block.location.x + " " + (block.location.y + 1.3) + " " + block.location.z);
                    player.runCommandAsync("/playsound block.grindstone.use @a [r=6] " + block.location.x + " " + block.location.y + " " + block.location.z);
                    player.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"§l§fNow This §uElevator §fis : §uLocked"}]}');
                }
            } else if (block.hasTag("down_only")) {
                if (respone.selection == 0) {
                    player.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " " + block.typeId);
                    player.runCommandAsync("/particle minecraft:critical_hit_emitter " + block.location.x + " " + (block.location.y + 1.3) + " " + block.location.z);
                    player.runCommandAsync("/playsound block.grindstone.use @a [r=6] " + block.location.x + " " + block.location.y + " " + block.location.z);
                    player.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"§l§fNow This §uElevator §fis : §uUp & Down"}]}');
                } else if (respone.selection == 1) {
                    player.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " " + block.typeId + ' ["ox:up_only"=true]');
                    player.runCommandAsync("/particle minecraft:critical_hit_emitter " + block.location.x + " " + (block.location.y + 1.3) + " " + block.location.z);
                    player.runCommandAsync("/playsound block.grindstone.use @a [r=6] " + block.location.x + " " + block.location.y + " " + block.location.z);
                    player.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"§l§fNow This §uElevator §fis : §uUp Only"}]}');
                } else if (respone.selection == 2) {
                    player.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " " + block.typeId + ' ["ox:locked_mode"=true]');
                    player.runCommandAsync("/particle minecraft:critical_hit_emitter " + block.location.x + " " + (block.location.y + 1.3) + " " + block.location.z);
                    player.runCommandAsync("/playsound block.grindstone.use @a [r=6] " + block.location.x + " " + block.location.y + " " + block.location.z);
                    player.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"§l§fNow This §uElevator §fis : §uLocked"}]}');
                }
            } else if (block.hasTag("locked_mode")) {
                if (respone.selection == 0) {
                    player.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " " + block.typeId);
                    player.runCommandAsync("/particle minecraft:critical_hit_emitter " + block.location.x + " " + (block.location.y + 1.3) + " " + block.location.z);
                    player.runCommandAsync("/playsound block.grindstone.use @a [r=6] " + block.location.x + " " + block.location.y + " " + block.location.z);
                    player.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"§l§fNow This §uElevator §fis : §uUp & Down"}]}');
                } else if (respone.selection == 1) {
                    player.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " " + block.typeId + ' ["ox:up_only"=true]');
                    player.runCommandAsync("/particle minecraft:critical_hit_emitter " + block.location.x + " " + (block.location.y + 1.3) + " " + block.location.z);
                    player.runCommandAsync("/playsound block.grindstone.use @a [r=6] " + block.location.x + " " + block.location.y + " " + block.location.z);
                    player.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"§l§fNow This §uElevator §fis : §uUp Only"}]}');
                } else if (respone.selection == 2) {
                    player.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " " + block.typeId + ' ["ox:down_only"=true]');
                    player.runCommandAsync("/particle minecraft:critical_hit_emitter " + block.location.x + " " + (block.location.y + 1.3) + " " + block.location.z);
                    player.runCommandAsync("/playsound block.grindstone.use @a [r=6] " + block.location.x + " " + block.location.y + " " + block.location.z);
                    player.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"§l§fNow This §uElevator §fis : §uDown Only"}]}');
                }
            }
            else if (!block.hasTag("up_only") && !block.hasTag("down_only")) {
                if (respone.selection == 0) {
                    player.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " " + block.typeId + ' ["ox:up_only"=true]');
                    player.runCommandAsync("/particle minecraft:critical_hit_emitter " + block.location.x + " " + (block.location.y + 1.3) + " " + block.location.z);
                    player.runCommandAsync("/playsound block.grindstone.use @a [r=6] " + block.location.x + " " + block.location.y + " " + block.location.z);
                    player.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"§l§fNow This §uElevator §fis : §uUp Only"}]}');
                } else if (respone.selection == 1) {
                    player.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " " + block.typeId + ' ["ox:down_only"=true]');
                    player.runCommandAsync("/particle minecraft:critical_hit_emitter " + block.location.x + " " + (block.location.y + 1.3) + " " + block.location.z);
                    player.runCommandAsync("/playsound block.grindstone.use @a [r=6] " + block.location.x + " " + block.location.y + " " + block.location.z);
                    player.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"§l§fNow This §uElevator §fis : §uDown Only"}]}');
                } else if (respone.selection == 2) {
                    player.runCommandAsync("/setblock " + block.location.x + " " + block.location.y + " " + block.location.z + " " + block.typeId + ' ["ox:locked_mode"=true]');
                    player.runCommandAsync("/particle minecraft:critical_hit_emitter " + block.location.x + " " + (block.location.y + 1.3) + " " + block.location.z);
                    player.runCommandAsync("/playsound block.grindstone.use @a [r=6] " + block.location.x + " " + block.location.y + " " + block.location.z);
                    player.runCommandAsync('/titleraw @s actionbar {"rawtext":[{"text":"§l§fNow This §uElevator §fis : §uLocked"}]}');
                }
            }
        });
    }
});

////////////////////////////////////////////////////////////////////

world.afterEvents.playerSpawn.subscribe((data) => {
    const player = data.player;

    if (player.hasTag("Delay῁")) {
        player.removeTag("Delay῁");
    }
});